import { useCache } from '../hooks/use-cache';
import { BACKWARD, FORWARD } from '../defaults';
import type { Ref, StyleValue, UnwrapRef, VNode } from 'vue';
import type { Alignment, GridConstructorProps, GridScrollOptions } from '../types';
import type { VirtualizedGridProps } from '../props';
declare const createGrid: ({ name, clearCache, getColumnPosition, getColumnStartIndexForOffset, getColumnStopIndexForStartIndex, getEstimatedTotalHeight, getEstimatedTotalWidth, getColumnOffset, getRowOffset, getRowPosition, getRowStartIndexForOffset, getRowStopIndexForStartIndex, initCache, injectToInstance, validateProps, }: GridConstructorProps<VirtualizedGridProps>) => import("vue").DefineComponent<{
    readonly className: import("element-pe/es/utils").BuildPropReturn<StringConstructor, "", unknown, unknown, unknown>;
    readonly containerElement: import("element-pe/es/utils").BuildPropReturn<import("element-pe/es/utils").PropWrapper<string | Element>, "div", unknown, unknown, unknown>;
    readonly data: import("element-pe/es/utils").BuildPropReturn<import("element-pe/es/utils").PropWrapper<any[]>, () => [], unknown, unknown, unknown>;
    readonly direction: import("element-pe/es/utils").BuildPropReturn<StringConstructor, "ltr", false, "ltr" | "rtl", never>;
    readonly height: import("element-pe/es/utils").BuildPropReturn<readonly [StringConstructor, NumberConstructor], unknown, true, unknown, unknown>;
    readonly innerElement: import("element-pe/es/utils").BuildPropReturn<readonly [StringConstructor, ObjectConstructor], "div", unknown, unknown, unknown>;
    readonly style: import("element-pe/es/utils").BuildPropReturn<import("element-pe/es/utils").PropWrapper<StyleValue>, unknown, unknown, unknown, unknown>;
    readonly useIsScrolling: import("element-pe/es/utils").BuildPropReturn<BooleanConstructor, false, unknown, unknown, unknown>;
    readonly width: import("element-pe/es/utils").BuildPropReturn<readonly [NumberConstructor, StringConstructor], unknown, false, unknown, unknown>;
    readonly perfMode: import("element-pe/es/utils").BuildPropReturn<BooleanConstructor, true, unknown, unknown, unknown>;
    readonly scrollbarAlwaysOn: import("element-pe/es/utils").BuildPropReturn<BooleanConstructor, false, unknown, unknown, unknown>;
    readonly columnCache: import("element-pe/es/utils").BuildPropReturn<NumberConstructor, 2, false, never, never>;
    readonly columnWidth: import("element-pe/es/utils").BuildPropReturn<import("element-pe/es/utils").PropWrapper<number | import("../types").ItemSize>, never, true, never, never>;
    readonly estimatedColumnWidth: import("element-pe/es/utils").BuildPropReturn<NumberConstructor, never, false, never, never>;
    readonly estimatedRowHeight: import("element-pe/es/utils").BuildPropReturn<NumberConstructor, never, false, never, never>;
    readonly initScrollLeft: import("element-pe/es/utils").BuildPropReturn<NumberConstructor, 0, false, never, never>;
    readonly initScrollTop: import("element-pe/es/utils").BuildPropReturn<NumberConstructor, 0, false, never, never>;
    readonly itemKey: import("element-pe/es/utils").BuildPropReturn<import("element-pe/es/utils").PropWrapper<import("../types").GridItemKeyGetter>, ({ columnIndex, rowIndex }: {
        columnIndex: any;
        rowIndex: any;
    }) => string, unknown, unknown, unknown>;
    readonly rowCache: import("element-pe/es/utils").BuildPropReturn<NumberConstructor, 2, false, never, never>;
    readonly rowHeight: import("element-pe/es/utils").BuildPropReturn<import("element-pe/es/utils").PropWrapper<number | import("../types").ItemSize>, never, true, never, never>;
    readonly totalColumn: import("element-pe/es/utils").BuildPropReturn<NumberConstructor, never, true, never, never>;
    readonly totalRow: import("element-pe/es/utils").BuildPropReturn<NumberConstructor, never, true, never, never>;
    readonly hScrollbarSize: import("element-pe/es/utils").BuildPropReturn<NumberConstructor, 6, unknown, unknown, unknown>;
    readonly vScrollbarSize: import("element-pe/es/utils").BuildPropReturn<NumberConstructor, 6, unknown, unknown, unknown>;
    readonly scrollbarStartGap: import("element-pe/es/utils").BuildPropReturn<NumberConstructor, 0, unknown, unknown, unknown>;
    readonly scrollbarEndGap: import("element-pe/es/utils").BuildPropReturn<NumberConstructor, 2, unknown, unknown, unknown>;
}, () => VNode<import("vue").RendererNode, import("vue").RendererElement, {
    [key: string]: any;
}>, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, ("scroll" | "itemRendered")[], "scroll" | "itemRendered", import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    readonly className: import("element-pe/es/utils").BuildPropReturn<StringConstructor, "", unknown, unknown, unknown>;
    readonly containerElement: import("element-pe/es/utils").BuildPropReturn<import("element-pe/es/utils").PropWrapper<string | Element>, "div", unknown, unknown, unknown>;
    readonly data: import("element-pe/es/utils").BuildPropReturn<import("element-pe/es/utils").PropWrapper<any[]>, () => [], unknown, unknown, unknown>;
    readonly direction: import("element-pe/es/utils").BuildPropReturn<StringConstructor, "ltr", false, "ltr" | "rtl", never>;
    readonly height: import("element-pe/es/utils").BuildPropReturn<readonly [StringConstructor, NumberConstructor], unknown, true, unknown, unknown>;
    readonly innerElement: import("element-pe/es/utils").BuildPropReturn<readonly [StringConstructor, ObjectConstructor], "div", unknown, unknown, unknown>;
    readonly style: import("element-pe/es/utils").BuildPropReturn<import("element-pe/es/utils").PropWrapper<StyleValue>, unknown, unknown, unknown, unknown>;
    readonly useIsScrolling: import("element-pe/es/utils").BuildPropReturn<BooleanConstructor, false, unknown, unknown, unknown>;
    readonly width: import("element-pe/es/utils").BuildPropReturn<readonly [NumberConstructor, StringConstructor], unknown, false, unknown, unknown>;
    readonly perfMode: import("element-pe/es/utils").BuildPropReturn<BooleanConstructor, true, unknown, unknown, unknown>;
    readonly scrollbarAlwaysOn: import("element-pe/es/utils").BuildPropReturn<BooleanConstructor, false, unknown, unknown, unknown>;
    readonly columnCache: import("element-pe/es/utils").BuildPropReturn<NumberConstructor, 2, false, never, never>;
    readonly columnWidth: import("element-pe/es/utils").BuildPropReturn<import("element-pe/es/utils").PropWrapper<number | import("../types").ItemSize>, never, true, never, never>;
    readonly estimatedColumnWidth: import("element-pe/es/utils").BuildPropReturn<NumberConstructor, never, false, never, never>;
    readonly estimatedRowHeight: import("element-pe/es/utils").BuildPropReturn<NumberConstructor, never, false, never, never>;
    readonly initScrollLeft: import("element-pe/es/utils").BuildPropReturn<NumberConstructor, 0, false, never, never>;
    readonly initScrollTop: import("element-pe/es/utils").BuildPropReturn<NumberConstructor, 0, false, never, never>;
    readonly itemKey: import("element-pe/es/utils").BuildPropReturn<import("element-pe/es/utils").PropWrapper<import("../types").GridItemKeyGetter>, ({ columnIndex, rowIndex }: {
        columnIndex: any;
        rowIndex: any;
    }) => string, unknown, unknown, unknown>;
    readonly rowCache: import("element-pe/es/utils").BuildPropReturn<NumberConstructor, 2, false, never, never>;
    readonly rowHeight: import("element-pe/es/utils").BuildPropReturn<import("element-pe/es/utils").PropWrapper<number | import("../types").ItemSize>, never, true, never, never>;
    readonly totalColumn: import("element-pe/es/utils").BuildPropReturn<NumberConstructor, never, true, never, never>;
    readonly totalRow: import("element-pe/es/utils").BuildPropReturn<NumberConstructor, never, true, never, never>;
    readonly hScrollbarSize: import("element-pe/es/utils").BuildPropReturn<NumberConstructor, 6, unknown, unknown, unknown>;
    readonly vScrollbarSize: import("element-pe/es/utils").BuildPropReturn<NumberConstructor, 6, unknown, unknown, unknown>;
    readonly scrollbarStartGap: import("element-pe/es/utils").BuildPropReturn<NumberConstructor, 0, unknown, unknown, unknown>;
    readonly scrollbarEndGap: import("element-pe/es/utils").BuildPropReturn<NumberConstructor, 2, unknown, unknown, unknown>;
}>> & {
    onScroll?: ((...args: any[]) => any) | undefined;
    onItemRendered?: ((...args: any[]) => any) | undefined;
}, {
    data: any[];
    width: import("element-pe/es/utils").BuildPropType<readonly [NumberConstructor, StringConstructor], unknown, unknown>;
    style: StyleValue;
    className: string;
    direction: import("element-pe/es/utils").BuildPropType<StringConstructor, "ltr" | "rtl", never>;
    scrollbarAlwaysOn: import("element-pe/es/utils").BuildPropType<BooleanConstructor, unknown, unknown>;
    perfMode: import("element-pe/es/utils").BuildPropType<BooleanConstructor, unknown, unknown>;
    containerElement: import("element-pe/es/utils").BuildPropType<import("element-pe/es/utils").PropWrapper<string | Element>, unknown, unknown>;
    innerElement: import("element-pe/es/utils").BuildPropType<readonly [StringConstructor, ObjectConstructor], unknown, unknown>;
    useIsScrolling: import("element-pe/es/utils").BuildPropType<BooleanConstructor, unknown, unknown>;
    estimatedRowHeight: number;
    itemKey: import("../types").GridItemKeyGetter;
    columnCache: number;
    estimatedColumnWidth: number;
    initScrollLeft: number;
    initScrollTop: number;
    rowCache: number;
    hScrollbarSize: number;
    vScrollbarSize: number;
    scrollbarStartGap: number;
    scrollbarEndGap: number;
}>;
export default createGrid;
declare type Dir = typeof FORWARD | typeof BACKWARD;
export declare type GridInstance = InstanceType<ReturnType<typeof createGrid>> & UnwrapRef<{
    windowRef: Ref<HTMLElement>;
    innerRef: Ref<HTMLElement>;
    getItemStyleCache: ReturnType<typeof useCache>;
    scrollTo: (scrollOptions: GridScrollOptions) => void;
    scrollToItem: (rowIndex: number, columnIndex: number, alignment: Alignment) => void;
    states: Ref<{
        isScrolling: boolean;
        scrollLeft: number;
        scrollTop: number;
        updateRequested: boolean;
        xAxisScrollDir: Dir;
        yAxisScrollDir: Dir;
    }>;
}>;
